	org &9000

.hazards
	ld b,5
.hazloop
	push bc
	ld hl,(bubptr)
	ld e,(hl)
	inc hl
	ld d,(hl)

	ld hl,haz1
	ex hl,de
	call &a47d

	ld hl,(bubptr)
	inc hl
	inc hl
	ld (bubptr),hl
	
	pop bc
	djnz hazloop		

	ld hl,bubpos
	ld (bubptr),hl

	ret

;; Move Bubbles

	org &9030

.movinit
	ld b,5
.movebubbles
	push bc

	ld hl,(bubptr)
	ld e,(hl)
	inc hl
	ld d,(hl)

	ld hl,blankspr
	ex hl,de
	call &a47d

	ld hl,(bubptr)		 
	ld e,(hl)		;; bubble position is
	inc hl
	ld d,(hl)		;; stored in de

	ex hl,de		;; move it to hl

	push hl			;; and preserve

	ld hl,(dirp)		;; directional pointer
	ld e,(hl)		;; value goes
	inc hl
	ld d,(hl)		;; into de
	pop hl			;; restore bubble position

	add hl,de		;; new bubble position in hl

	ex hl,de		;; new bubble position in de

	ld hl,(bubptr)
	ld (hl),e		;; store new bubble position
	inc hl
	ld (hl),d		;; to appropriate bubble position

	ld hl,(bubptr)
	ld e,(hl)		;; gather the new position
	inc hl
	ld d,(hl)		;; by placing into de

	ld hl,haz1		;; sprite to use
	ex hl,de		;; is switched into de
	call &a47d		;; sprite driver

	call whichway		;; check which way the bubbles move

	ld hl,(bubptr)	
	inc hl			;; increment to the
	inc hl			;; next bubble positions
	ld (bubptr),hl

	ld hl,(dirp)
	inc hl			;; increment to the
	inc hl			;; next directional position
	ld (dirp),hl

	ld hl,(bubblexp)
	inc hl			;; increment to the next bubble x position
	ld (bubblexp),hl

	ld a,(chkdrp)
	inc a			;; increment to the next check directional position
	ld (chkdrp),a

	pop bc			;; restore b
	djnz movebubbles	;; if not 0 return to the next position

	ld hl,bubpos
	ld (bubptr),hl		;; restore to initial bubble position

	ld hl,dircton
	ld (dirp),hl		;; restore to initial direction position

	ld hl,chkdir
	ld (chkdrp),hl		;; restore to initial check directional position

	ld hl,bubblex
	ld (bubblexp),hl	;; restore to initial bubble xpos position

	ret			;; and return to BASIC

.whichway

	ld hl,(chkdrp)		;; check directional pointer
	ld a,(hl)		;; is stored in a
	and a			;; if it equals 0
	jr nz,incr		;; jump if it is not 0

	ld hl,(bubblexp)	;; bubble xpos pointer
	ld a,(hl)		;; goes into a
	dec a			;; decrease it
	ld (hl),a		;; and store new position

	jr checkpos		;; jump to check position

.incr				;; else if 0 was found
	ld hl,(bubblexp)	;; bubble xpos pointer
	ld a,(hl)		;; goes into a
	inc a			;; increase it
	ld (hl),a		;; and store new value

.checkpos			;; now check position onscreen
	ld hl,(bubblexp)	;; bubble xpos pointer
	ld a,(hl)		;; contents stored in a
	cp 3			;; if this equals 3
	jr nz,rightside		;; jump if not equal to 3

	ld hl,(dirp)		;; directional pointer
	ld de,4			;; 4 goes into de
	ld (hl),e		;; and place new value
	inc hl
	ld (hl),d		;; into the directional area

	ld hl,(chkdrp)		;; check directional pointer
	ld a,1			;; 1 is then stored
	ld (hl),a		;; into check direction

	jr done			;; is now complete

.rightside			;; else if not found
	ld hl,(bubblexp)	;; bubble xpos pointer
	ld a,(hl)		;; contents stored into a
	cp 18			;; if this equals 18
	jr nz,done		;; jump if not equal to 18

	ld hl,(dirp)	
	ld de,-4		;; else change directional
	ld (hl),e
	inc hl
	ld (hl),d		;; area to 4

	ld hl,(chkdrp)		;; and check direction
	xor a
	ld (hl),a		;; becomes 0

.done	ret			;; return to move bubbles 


.dirp	defw dircton
.chkdrp
	defw chkdir
.chkdir	defb 1,0,1,0,1
.bubblexp
	defw bubblex
.bubblex
	defb 10,9,4,16,12
.dircton
	defw 4,-4,4,-4,4
.bubptr	defw bubpos
.bubpos
	defw &c164,&c250,&c32c,&c44c,&c52c

;; Controls the Speed of the Bubbles

	org &9110

	ld a,(numpos)		;; increment speed number
	inc a			
	ld (numpos),a
	cp 5			;; this controls the speed of the bubbles
;;	ret nz			;; if it hasn't reach that speed value exit
	jr nz,incend
	xor a			;; otherwise return to zero
	ld (numpos),a		;; and place into numpos
	call &9030		;; and call the routine to move the bubbles

.incend	ret			;; then exit

.numpos	defb 0

	org &9130

	ld hl,&a650
	ld (addr1),hl
	ld hl,&a651
	ld (addr2),hl
	ld hl,&a327
	ld (addr3),hl
	call &a32b

	ld hl,&a652
	ld (addr1),hl
	ld hl,&a653
	ld (addr2),hl
	ld hl,&a328
	ld (addr3),hl
	call &a32b

	ld hl,&a654
	ld (addr1),hl
	ld hl,&a655
	ld (addr2),hl
	ld hl,&a329
	ld (addr3),hl
	call &a32b

	ld hl,&a656
	ld (addr1),hl
	ld hl,&a657
	ld (addr2),hl
	ld hl,&a32a
	ld (addr3),hl
	call &a32b

	ret

	org &9185

	ld de,253
	ld hl,matrix
	call &bbab
	ld hl,redgfx
	ld de,matrix
	ld bc,24
	ldir

	ld a,8
	ld (txtheight),a
	ld a,24
	ld (txtwidth),a
	ld hl,title
	ld (titleptr),hl
	call drawtext
	ret

	ld a,11
	ld (txtheight),a
	ld a,16
	ld (txtwidth),a
	ld hl,title2
	ld (titleptr),hl
	call drawtext
	ret

.drawtext
	ld a,1
	call &bc59

	ld a,(txtheight)
	ld b,a	
.yloop
	push bc
	ld a,(txtwidth)
	ld b,a
.xloop
	push bc
	ld hl,(titleptr)
	ld a,(hl)
	cp 1
	jr nz,iszero
	ld a,8
	call &bbde
	ld hl,(xposition)
	ex hl,de
	ld hl,(yposition)
	call &bbc0
	ld a,255
	call &bbfc
	ld a,9
	ld hl,(xposition)
	ex hl,de
	ld hl,(yposition)
	call &bbc0
	call &bbde
	ld a,254
	call &bbfc
.iszero
	ld hl,(titleptr)
	inc hl
	ld (titleptr),hl
	ld hl,(xposition)
	ld de,16
	add hl,de
	ld (xposition),hl
	pop bc
	djnz xloop
	ld hl,(yposition)
	ld de,16
	and a
	sbc hl,de
	ld (yposition),hl
	ld hl,(xrestore)
	ld (xposition),hl
	pop bc
	djnz yloop

	ld hl,(xrestore)
	ld (xposition),hl
	ld hl,366
	ld (yposition),hl
	ld hl,title
	ld (titleptr),hl

	ld a,0
	call &bc59

	ret

.xposition
	defw 144
.yposition
	defw 366
.xrestore
	defw 144
.titleptr
	defw title
.txtheight
	defb 0
.txtwidth
	defb 0
.matrix	defb 0,0,0,0,0,0,0,0
	defb 0,0,0,0,0,0,0,0
	defb 0,0,0,0,0,0,0,0

.redgfx	defb 126,129,129,129,133,129,129,129
	defb 0,0,0,0,96,96,0,0
	defb 0,0,96,240,144,144,240,96

.title	defb 1,1,1,0,1,0,1,0,1,1,1,0,1,1,1,0,1,0,0,0,1,1,1,0
	defb 1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,0,0,1,0,0,0
	defb 1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,0,0,1,0,0,0
	defb 1,1,0,0,1,0,1,0,1,1,0,0,1,1,0,0,1,0,0,0,1,1,1,0
	defb 1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,0,0,1,0,0,0
	defb 1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,0,0,1,0,0,0
	defb 1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,0,0,1,0,0,0
	defb 1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0

.title2
	defb 1,0,1,0,1,1,1,0,1,0,0,0,1,0,0,0
	defb 1,0,1,0,1,0,0,0,1,0,0,0,1,0,0,0
	defb 1,0,1,0,1,1,0,0,1,0,0,0,1,0,0,0
	defb 1,1,1,0,1,0,0,0,1,0,0,0,1,0,0,0
	defb 1,0,1,0,1,1,1,0,1,1,1,0,1,1,1,0
	defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	defb 1,1,0,0,0,1,0,0,0,0,0,0,1,1,1,0
	defb 1,0,1,0,1,0,1,0,1,1,1,0,1,0,0,0
	defb 1,0,1,0,1,0,1,0,1,0,1,0,1,1,0,0
	defb 1,0,1,0,1,0,1,0,1,0,1,0,1,0,0,0
	defb 1,1,0,0,0,1,0,0,1,0,1,0,1,1,1,0

	ld hl,colours
.setinks
	ld c,(hl)
	ld b,c
	push af
	push hl
	call &bc32		;; SCR SET INK
	pop hl
	pop af
	inc hl
	inc a
	cp 16
	jr c,setinks
	ret
.colours
	defb 0,12,3,6,26,24,9,15,23,20,0,16,10,0,0,0

	org &a1f4

;; This is used by the BASIC section to reference Sprite Address 
;; during Gameplay. If the main character shall be in front of
;; a ladder or platform, as soon as the character has move to
;; the next position, the old position of the array is used
;; and value from the array is used to calculate these positions. 

.blank	defw &a5ba
.plat	defw &a5da
.ladder	defw &a5fa

;;	org &a1fa
.wvar	defb 0
.zvar	defb 0
.avar	defb 0
.bvar	defb 0
.sc	defw 0



;; Setup Memory Array

	org &a200

.cleararray

	call reset		;; reset values to 0

	ld b,25
.lpy1
	ld a,(ypos)
	inc a
	ld (ypos),a

	push bc
	ld b,20
.lpx1
	ld a,(xpos)
	inc a
	ld (xpos),a

	push bc
	call arraysetup
	pop bc

	ld hl,(arraypos)
	xor a			;;	ld a,0
	ld (hl),a

	djnz lpx1

	ld a,(xpos)
	xor a
	ld (xpos),a

	pop bc
	djnz lpy1

.placeplatforms

	call reset

	ld b,7			;; number of platforms
.lpy2
	ld a,(ypos)
	inc a
	inc a			;; place one every   
	inc a			;; three rows
	ld (ypos),a

	push bc
	ld b,20			;; across the screen
.lpx2
	ld a,(xpos)
	inc a
	ld (xpos),a

	push bc
	call arraysetup		;; obtain positon for Memory Array
	pop bc

	ld hl,(arraypos)
	ld a,1			;; set value of 1 to represent platform
	ld (hl),a		;; and store in memory array.

	djnz lpx2		;; loop until across the screen is reached

	ld a,(xpos)
	xor a			;; return xpos to zero
	ld (xpos),a

	pop bc			;; restore number of platforms
	djnz lpy2		;; and decrease by 1.


.placeladders

	call reset

	ld a,3			;; start position of ladder
	ld (ypos),a
.lp3	
	ld a,(ypos)
	cp 3			;; if it equals 3
	jr z,fnd		;; jump to found
	cp 9			;; if it equals 9
	jr z,fnd		;; jump to found
	cp 15			;; if it equals 15
	jr z,fnd		;; jump to found

	ld a,19			;; else assign a value of 19
	ld (xpos),a		;; to xpos
	jr alt			;; and jump found routine
.fnd
	ld a,2			;; if values found assign a
	ld (xpos),a		;; value of 2 to xpos.
.alt
	ld b,3			;; Number of times to loop down
.lpdn3
	push bc
	call arraysetup		;; obtain position of memory array
	pop bc

	ld hl,(arraypos)	
	ld a,2			;; set value of 2 to represent ladder
	ld (hl),a		;; and place in Memory Array.

	ld a,(ypos)
	inc a			;; Increment to the Next Y position
	ld (ypos),a

	djnz lpdn3		;; Carry out 3 times.

	ld b,20			;; If Y position is less than 20
	ld a,(ypos)
	cp b
	jr c,lp3		;; Loop back to the start.

	ret			;; Exit to BASIC.

.reset
	xor a			;; a = 0
	ld (ypos),a		;; ypos = 0
	ld (xpos),a		;; xpos = 0
	ret
	

.arraysetup

	;; Entry: Xpos, Ypos
	;; Exit: Address of Array

	ld a,(ypos)		;; ypos needs to be stored
	ld b,a			;; in b register
	ld de,20		;; represent the width of the memory array
	ld hl,&9feb		;; base address 
.calypos
	add hl,de		;; add 20 to the base address
	djnz calypos		;; carry this out until number of y positions is reached

	ld (arraypos),hl	;; store array position

	ld a,(xpos)		;; xpos
 	ld b,a			;; is stored in b register
	ld hl,(arraypos)	;; Lookup previous array position
.calxpos
	inc hl			;; increment it
	djnz calxpos		;; until b = 0

	ld (arraypos),hl	;; final position of the array

	ret			;; Return to earlier setup routines.

.xpos	defb 0
.ypos	defb 0
.arraypos
	defw 0


	org &a2c8

	;; I wrote these routines to replace a set of conditional checks I made in BASIC. 
	;; The first routine checks if the main character is over a piece of fruit and in
	;; the correct sequence. If it's in the correct sequence bonus points are rewarded,
	;; otherwise the second routine comes into action and awards minor points.

	;; call &a2c8,w,z,a,b

	ld a,(ix+00)		;; b variable
	ld (bvar),a	
	ld a,(ix+02)		;; a variable
	ld (avar),a
	ld a,(ix+04)		;; z variable
	ld (zvar),a
	ld a,(ix+06)		;; w variable
	ld (wvar),a

	ld a,(bvar)	
	ld b,a			;; store contents of b variable into b register
	ld hl,&a64f		;; address which points to selected x coordinates of the fruit
.find1pos
	inc hl			;; increment this
	djnz find1pos		;; until b equals 0

	ld a,(hl)		;; selected coordinates is stored in accumulator
	ld b,a			;; and then placed into b
	ld a,(wvar)		;; x coordinates of main character 
	cp b			;; is checked with coordinates of fruit
	jr nz,over		;; if it does not equal it, exit.

	ld a,(bvar)
	ld b,a
	ld hl,&a650		;; address which points to the select y coordinates of the fruit
.find2pos
	inc hl			;; increment its place based on position of b variable
	djnz find2pos		;; until b equals 0

	ld a,(hl)		;; place the selected coordinates into the accumulator
	ld b,a			;; and then into b
	ld a,(zvar)		;; y coordinates of main character
	cp b			;; is checked with coordinates of fruit
	jr nz,over		;; if it does not equal it, exit.

	ld a,(avar)		;; else accumulator equals a variable pointer
	ld b,a			;; place into b
	ld hl,&a326		;; hl equals base position of fruit - 1
.find3pos
	inc hl			;; increase to that spot
	djnz find3pos		;; until b = 0
	
	ld a,(hl)		;; value of fruit is stored into a
	or a			;; if it equals 0 ;; cp 0
	jr z,over		;; jump to over

	ld hl,(sc)		;; else place score into hl
	ld de,25		;; 25 bonus points into de
	add hl,de		;; increase
	ld (sc),hl		;; then store into score.

	ld hl,avar		;; hl = address of avar ptr position 
	inc (hl)		;; increase it contents by 1 
	
	ld hl,bvar		;; hl = address of bvar ptr position
	inc (hl)		;; increase contents 
	inc (hl)		;; by 2.

.over	ret			;; return to BASIC


;; Check Positions in Relation to the Fruit & Veg

	org &a32b

	;; This checks if the main character has move to grab
	;; the Fruit and Veg, but is out of sequence.

	;; Correct sequence in this game is Tomato, Pumpkin, Lemon & Water Mellon.	

	;; A series of checks in BASIC to this routine to see if the character is situated 
	;; where some fruit is placed. If it doesn't, this routine exits. If the first value
	;; is in line with the fruit a second check is made <addr2>, if it doesn't the routine
	;; exits. If for some reason those first 2 checks equal where some fruit is or was 
	;; <addr3> is used to check the points allocated, if it equals 0, the fruit or veg
	;; has been taken and no further points are allocated, if it hasn't, but is out of 
	;; order minor points are awarded and set to zero to represent it being taken.

	ld hl,(addr3)
	ld a,(hl)
	or a
	ret z

	ld hl,(addr1)
	ld a,(hl)
	ld b,a
	ld a,(wvar)
	cp b
	ret nz

	ld hl,(addr2)
	ld a,(hl)
	ld b,a
	ld a,(zvar)
	cp b
	ret nz

	ld hl,(addr3)
	ld a,(hl)
	ld b,a
	ld a,(avar)
	cp b
	ret z

	ld e,b
	ld d,0
	ld hl,(sc)
	add hl,de
	ld (sc),hl

	ld hl,(addr3)
	xor a			;; ld a,0
	ld (hl),a

.exit	ret

.addr1	defw 0
.addr2	defw 0
.addr3	defw 0

;; Draw Game Screen Routines

	org &a400

	ld hl,&c000
	ld (scrmap),hl		;; for sprite driver

.loop
	ld hl,(screen)
	ld a,(hl)		;; check value in memory array
	cp 0			;; if it equals zero
	jr z,nextpos		;; skip to the next position (no drawing necessary)

	ld hl,(screen)
	ld a,(hl)
	cp 1			;; if it equals one
	jr z,isplat		;; jump to platform
	ld hl,&a5fa		;; otherwise its an ladder
	ld (graddr),hl
	jr draw			;; and jump to draw
.isplat
	ld hl,&a5da		;; assign address value for platform
	ld (graddr),hl		;; and store to use with Sprite Driver

.draw	ld hl,(graddr)
	ex hl,de
	ld hl,(scrmap)		;; screen address
	call &a47d		;; sprite driver

.nextpos
	ld hl,(scrmap)
	inc hl
	inc hl			;; increment 4 times as this is a 8x8 sprite 
	inc hl
	inc hl
	ld (scrmap),hl		;; to screen map.

	ld hl,(screen)		 
	inc hl			;; increase to the next position of
	ld (screen),hl		;; the memory array.

	ld hl,(first)
	inc hl			;; increase to the next loop position
	ld (first),hl

	ld hl,(first)
	ld de,(second)		;; this is carried out 479 times and if not
	and a
	sbc hl,de
	jr nz,loop		;; reached return until it has been completed.

	ld hl,&a000
	ld (screen),hl		;; once reached return variables 
	ld hl,0
	ld (first),hl		;; to their original values.
	ret

.first	defw 0
.second	defw 479
.screen	defw &a000
.graddr	defw &a5ba
.scrmap	defw &c000

	org &a46a

	defb 0,1,2,14,11

;; Sprite Driver


	org &a470

	;; CALL &A470,<sprite>,<screen address>

	;; CALL &A470,&A49A,<screen address> - Hazard 1 (Rolling Barrel)
	;; CALL &A470,&A4BA,<screen address> - Hazard 2 (Rolling Barrel)
	;; CALL &A470,&A4DA,<screen address> - Main Character Right Face
	;; CALL &A470,&A4FA,<screen address> - Main Character Left Face
	;; CALL &A470,&A51A,<screen address> - Tomato 
	;; CALL &A470,&A53A,<screen address> - Pumpkin
	;; CALL &A470,&A55A,<screen address> - Lemon
	;; CALL &A470,&A57A,<screen address> - Water Mellon
	;; CALL &A470,&A59A,<screen address> - Main Character from Behind
	;; CALL &A470,&A5BA,<screen address> - Blank

	;; INKs Used:
	;;  0,11 1,12 2,3 3,6 4,26 5,24 6,9 7,15 
        ;;  8,23 9,20 10,0 11,16 12,10 15,9,background colour

	ld l,(ix+&02)
	ld h,(ix+&03)		;; sprite address
	ex hl,de		;; store in de
	ld l,(ix+&00)
	ld h,(ix+&01)		;; screen address
	ld (scradr),hl		;; place to store screen address
	ld b,8		;; row
.rloop
	push bc
	ld b,4		;; column
.ploop
	ld a,(de)		;; contents of sprite
	ld (hl),a		;; is drawn to screen
	inc de			;; increase to next position of sprite
	inc hl			;; and next position of the screen
	djnz ploop		;; do this 4 times
	
	ld hl,(scradr)		;; then work out next position 
	call &bc26
	ld (scradr),hl		;; of the screen

	pop bc
	djnz rloop		;; and do this 8 times

	ret			;; then return where called from.

.scradr
	defw &c000

.haz1
	defb 0,0,0,0
	defb 0,0,0,0
	defb 0,0,0,0
	defb 1,3,0,0
	defb 3,195,2,0
	defb 67,195,2,0
	defb 67,131,2,0
	defb 1,3,0,0

.haz2
	defb 0,255,255,0
	defb 17,255,255,34
	defb 119,255,255,187
	defb 119,255,255,187
	defb 114,177,177,51
	defb 114,240,240,51
	defb 17,177,177,34
	defb 0,114,51,0

.man1	
	defb 0,4,8,0
	defb 0,24,142,0
	defb 4,207,207,8
	defb 4,154,207,8
	defb 77,154,36,0
	defb 77,207,142,0
	defb 16,12,32,0
	defb 16,32,48,0

.man2
	defb 0,12,0,0
	defb 4,154,8,0
	defb 77,207,142,0
	defb 77,154,142,0
	defb 4,48,207,8
	defb 4,207,207,8
	defb 0,36,24,0
	defb 16,32,48,0

.tomato
	defb 20,40,60,0
	defb 0,104,40,0
	defb 68,200,204,0
	defb 204,204,204,136
	defb 204,204,204,136
	defb 204,204,204,136
	defb 68,204,204,0
	defb 0,204,136,0

.pumpkin
	defb 0,0,0,0
	defb 0,0,0,0
	defb 84,252,0,0
	defb 252,252,188,20
	defb 252,252,252,128
	defb 252,252,252,128
	defb 252,252,188,20
	defb 84,252,0,0

.lemon
	defb 0,40,40,0
	defb 0,80,0,0
	defb 0,240,160,0
	defb 80,240,240,0
	defb 240,240,240,160
	defb 240,240,240,160
	defb 80,240,240,0
	defb 0,240,160,0

.mellon
	defb 108,204,204,156
	defb 108,204,204,156
	defb 108,204,204,156
	defb 108,204,204,156
	defb 108,78,141,156
	defb 108,204,204,156
	defb 20,204,204,40
	defb 0,60,60,0

.man3	
	defb 0,5,10,0
	defb 0,5,10,0
	defb 0,142,77,0
	defb 0,12,12,0
	defb 0,12,12,0
	defb 0,5,10,0
	defb 0,5,10,0
	defb 0,37,26,0

.blankspr
	defb 0,0,0,0
	defb 0,0,0,0
	defb 0,0,0,0
	defb 0,0,0,0
	defb 0,0,0,0
	defb 0,0,0,0
	defb 0,0,0,0
	defb 0,0,0,0

.platform
	defb 204,204,204,204
	defb 51,51,51,51
	defb 51,102,153,51
	defb 51,153,102,51
	defb 102,51,51,153
	defb 153,51,51,102
	defb 51,51,51,51
	defb 204,204,204,204

.ladderspr
	defb 32,0,0,16
	defb 32,0,0,16
	defb 48,48,48,48
	defb 32,0,0,16
	defb 32,0,0,16
	defb 32,0,0,16
	defb 48,48,48,48
	defb 32,0,0,16
.end

